function varargout = MC_ParticleSim(varargin)
% MC_PARTICLESIM Application M-file for MC_ParticleSim.fig
%    FIG = MC_PARTICLESIM launch MC_ParticleSim GUI.
%    MC_PARTICLESIM('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 22-Jan-2003 11:26:03

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

   
	if nargout > 0
		varargout{1} = fig;
	end
    
    % set value for iterations and nr of particles
    set( handles.Iterations_Slider, 'Value', 1000 );
    set( handles.NrOfParticles_Slider, 'Value', 17 );    
    set( handles.InvTemp_Slider, 'Value', 10 );        
    set( handles.Iterations_Edit,'String', num2str(get(handles.Iterations_Slider,'Value')));
    set( handles.NrOfParticles_Edit,'String', num2str(get(handles.NrOfParticles_Slider,'Value')));
    set( handles.InvTemp_Edit,'String', num2str(get(handles.InvTemp_Slider,'Value')));    
    
    %
    % load logos
    %
    ITPLogo = imread('logo-itp.png');
    image( ITPLogo, 'Parent', handles.ITPLogo );
    set( handles.ITPLogo, 'Visible', 'off');            % disable axes
    
    TUGLogo = imread('logo-tug.png');
    image( TUGLogo, 'Parent', handles.TUGLogo );
    set( handles.TUGLogo, 'Visible', 'off');            % disable axes
    
    
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.

% --------------------------------------------------------------------
function varargout = InvTemp_Edit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.InvTemp_Edit.
val = str2num(get(handles.InvTemp_Edit,'String'));
if isnumeric(val) & length(val)==1 & ...
    val >= get(handles.InvTemp_Slider,'Min') & ...
    val <= get(handles.InvTemp_Slider,'Max')
    set(handles.InvTemp_Slider,'Value',val);
else
% Increment the error count, and display it
    handles.numberOfErrors = handles.numberOfErrors+1;
    set(handles.InvTemp_Edit,'String', [handles.errorString,num2str(handles.numberOfErrors)]);
    guidata(gcbo,handles); % store the changes...
end


% --------------------------------------------------------------------
function varargout = InvTemp_Slider_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.InvTemp_Slider.
set( handles.InvTemp_Edit,'String', num2str(get(handles.InvTemp_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
function varargout = NrOfParticles_Slider_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.NrOfParticles_Slider.
set( handles.NrOfParticles_Edit,'String', num2str(get(handles.NrOfParticles_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
function varargout = NrOfParticles_Edit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.NrOfParticles_Edit.
val = str2num(get(handles.NrOfParticles_Edit,'String'));
if isnumeric(val) & length(val)==1 & ...
    val >= get(handles.NrOfParticles_Slider,'Min') & ...
    val <= get(handles.NrOfParticles_Slider,'Max')
    set(handles.NrOfParticles_Slider,'Value',val);
else
% Increment the error count, and display it
    handles.numberOfErrors = handles.numberOfErrors+1;
    set(handles.NrOfParticles_Edit,'String', [handles.errorString,num2str(handles.numberOfErrors)]);
    guidata(gcbo,handles); % store the changes...
end

% --------------------------------------------------------------------
function varargout = Iterations_Edit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.Iterations_Edit.
val = str2num(get(handles.Iterations_Edit,'String'));
if isnumeric(val) & length(val)==1 & ...
    val >= get(handles.Iterations_Slider,'Min') & ...
    val <= get(handles.Iterations_Slider,'Max')
    set(handles.Iterations_Slider,'Value',val);
else
% Increment the error count, and display it
    handles.numberOfErrors = handles.numberOfErrors+1;
    set(handles.Iterations_Edit,'String', [handles.errorString,num2str(handles.numberOfErrors)]);
    guidata(gcbo,handles); % store the changes...
end


% --------------------------------------------------------------------
function varargout = Iterations_Slider_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.Iterations_Slider.
set( handles.Iterations_Edit,'String', num2str(get(handles.Iterations_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
% slider for iterations
function varargout = slider6_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider6.
set( handles.Iterations_Edit,'String', num2str(get(handles.Iterations_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
% slider for number of particles
function varargout = slider7_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider7.
set( handles.NrOfParticles_Edit,'String', num2str(get(handles.NrOfParticles_Slider,'Value')));
guidata(gcbo,handles);

% --------------------------------------------------------------------
%
% Calculate the distribution of point charges on a disk
% using Monte Carlo simulation that minimizes the potential energy!
%
% Author:   Chris Theis         01/21/02
%           ctheis@itp.tu-graz.ac.at
%
% --------------------------------------------------------------------
function varargout = RunBtn_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.RunBtn.
NrOfParticles = get( handles.NrOfParticles_Slider, 'Value');
Iterations = get( handles.Iterations_Slider, 'Value');
InvTemp = get( handles.InvTemp_Slider, 'Value');

% call the function the performs the Monte Carlo calculation
[X_Initial, Y_Initial, X, Y, PotEnergyArray] = MC_ParticlePos( InvTemp, Iterations, NrOfParticles );

% plot initial particle configuration
PosImage = zeros( 20, 20 );
for i = 1:NrOfParticles
    IndexX = floor( (2 + X_Initial(i)) * 5 );
    IndexY = floor( (2 + Y_Initial(i)) * 5 );
    PosImage( IndexX, IndexY ) = 35;
end
image( PosImage, 'Parent', handles.InitialFigure )

% plot final particle configuration
PosImage = zeros( 20, 20 );
for i = 1:NrOfParticles
    IndexX = floor( (2 + X(i)) * 5 );
    IndexY = floor( (2 + Y(i)) * 5 );
    PosImage( IndexX, IndexY ) = 35;
end
image( PosImage, 'Parent', handles.FinalFigure )

% plot potential energy as  a function of the MC step
plot( PotEnergyArray, 'Parent', handles.EnergyFigure )



