function varargout = MC_ParticleSim(varargin)
% MC_STOCKPRICE Application M-file for MC_ParticleSim.fig
%    FIG = MC_STOCKPRICE launch MC_ParticleSim GUI.
%    MC_STOCKPRICE('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 22-Jan-2003 11:26:03

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

   
	if nargout > 0
		varargout{1} = fig;
	end
    
    % set value for iterations and nr of particles
    set( handles.Iterations_Slider, 'Value', 1000 );
    set( handles.Mu_Slider, 'Value', 0.14 );    
    set( handles.Sigma_Slider, 'Value', 0.2 );        
    set( handles.Iterations_Edit,'String', num2str(get(handles.Iterations_Slider,'Value')));
    set( handles.Mu_Edit,'String', num2str(get(handles.Mu_Slider,'Value')));
    set( handles.Sigma_Edit,'String', num2str(get(handles.Sigma_Slider,'Value')));    
    
    %
    % load logos
    %
    ITPLogo = imread('logo-itp.png');
    image( ITPLogo, 'Parent', handles.ITPLogo );
    set( handles.ITPLogo, 'Visible', 'off');            % disable axes
    
    TUGLogo = imread('logo-tug.png');
    image( TUGLogo, 'Parent', handles.TUGLogo );
    set( handles.TUGLogo, 'Visible', 'off');            % disable axes
    
    
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.

% --------------------------------------------------------------------
function varargout = Sigma_Edit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.InvTemp_Edit.
val = str2num(get(handles.Sigma_Edit,'String'));
if isnumeric(val) & length(val)==1 & ...
    val >= get(handles.Sigma_Slider,'Min') & ...
    val <= get(handles.Sigma_Slider,'Max')
    set(handles.Sigma_Slider,'Value',val);
else
% Increment the error count, and display it
    handles.numberOfErrors = handles.numberOfErrors+1;
    set(handles.Sigma_Edit,'String', [handles.errorString,num2str(handles.numberOfErrors)]);
    guidata(gcbo,handles); % store the changes...
end


% --------------------------------------------------------------------
function varargout = Sigma_Slider_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.InvTemp_Slider.
set( handles.Sigma_Edit,'String', num2str(get(handles.Sigma_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
function varargout = Mu_Slider_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.NrOfParticles_Slider.
set( handles.Mu_Edit,'String', num2str(get(handles.Mu_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
function varargout = Mu_Edit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.NrOfParticles_Edit.
val = str2num(get(handles.Mu_Edit,'String'));
if isnumeric(val) & length(val)==1 & ...
    val >= get(handles.Mu_Slider,'Min') & ...
    val <= get(handles.Mu_Slider,'Max')
    set(handles.Mu_Slider,'Value',val);
else
% Increment the error count, and display it
    handles.numberOfErrors = handles.numberOfErrors+1;
    set(handles.Mu_Edit,'String', [handles.errorString,num2str(handles.numberOfErrors)]);
    guidata(gcbo,handles); % store the changes...
end

% --------------------------------------------------------------------
function varargout = Iterations_Edit_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.Iterations_Edit.
val = str2num(get(handles.Iterations_Edit,'String'));
if isnumeric(val) & length(val)==1 & ...
    val >= get(handles.Iterations_Slider,'Min') & ...
    val <= get(handles.Iterations_Slider,'Max')
    set(handles.Iterations_Slider,'Value',val);
else
% Increment the error count, and display it
    handles.numberOfErrors = handles.numberOfErrors+1;
    set(handles.Iterations_Edit,'String', [handles.errorString,num2str(handles.numberOfErrors)]);
    guidata(gcbo,handles); % store the changes...
end


% --------------------------------------------------------------------
function varargout = Iterations_Slider_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.Iterations_Slider.
set( handles.Iterations_Edit,'String', num2str(get(handles.Iterations_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
% slider for iterations
function varargout = slider6_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider6.
set( handles.Iterations_Edit,'String', num2str(get(handles.Iterations_Slider,'Value')));
guidata(gcbo,handles);


% --------------------------------------------------------------------
% slider for mu
function varargout = slider7_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slider7.
set( handles.Mu_Edit,'String', num2str(get(handles.Mu_Slider,'Value')));
guidata(gcbo,handles);

% --------------------------------------------------------------------
%
% Calculate a possible evolution of stock prices using a (very)
% simplified model based on a diffusion process (Brownian motion).
%
% This program is intended as a simple example for the application of
% Monte Carlo methods in finance. A more realistic implementation and
% analysis would require a deeper knowledge of financial theory.
% As this is intended as an outlook for possible applications and not
% as an application for stock brokers or other professionals, please
% refer to the bibliography section of the PDF file for further information.
%
% Author:   Chris Theis         03/21/02
%           ctheis@itp.tu-graz.ac.at
%
% --------------------------------------------------------------------
function varargout = RunBtn_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.RunBtn.
Mu = get( handles.Mu_Slider, 'Value');
Iterations = get( handles.Iterations_Slider, 'Value');
Sigma = get( handles.Sigma_Slider, 'Value');

Price = MC_Stock( Iterations, Mu, Sigma );

% plot price evolution
plot( Price, 'Parent', handles.StockPriceFigure )

% create histogram
nbins = 50;
xend = 50;
xanf = 0;
bins = zeros(nbins, 1);
delta = (xend - xanf) / nbins;

for i = 1:365
  if (Price(i) > xanf) & (Price(i) < xend)
    t = ceil ((Price(i) - xanf) / (xend - xanf) * nbins);
    bins(t) = bins(t) + 1; 
  end;  
end;

Z = sum( bins * delta);
bins = bins / Z;

for i = 1:nbins
  xx(i) = xanf + (i - 0.5) * delta;
end;  

% plot price evolution histogram
handle = bar( xx, bins );
set( handle, 'Parent', handles.PriceHisto );
close


