%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Histogram 
%
% (c) 1998 Chris Theis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function bins = histogramm(x, n, xanf, xend, nbins);

bins = zeros(nbins, 1);
delta = (xend - xanf) / nbins;

for i = 1:n
  if (x(i) > xanf) & (x(i) < xend)
    t = ceil ((x(i) - xanf) / (xend - xanf) * nbins);
    bins(t) = bins(t) + 1; 
  end;  
end;

Z = sum( bins * delta);
bins = bins / Z;

for i = 1:nbins
  xx(i) = xanf + (i - 0.5) * delta;
end;  

bar(xx, bins);

clear i;