%
% Calculate the volume of a n-dimensional sphere using Monte Carlo integration
% (c) 03/18/02 Chris Theis
%
%

clear all;
MaxDim = 20;
TimeVector = zeros(MaxDim,1);

for Dim = 2:MaxDim

  NrOfIterations = 50000;
  Counter = 0;
  RadiusSquared = 1.0;

  Vector = zeros( Dim, 1 );
  tic;
  for i = 1:NrOfIterations
     Vector = rand( Dim, 1);
     if( sum(Vector .* Vector) < RadiusSquared )
        Counter = Counter + 1;
     end
  end
  TimeVector( Dim, 1) = toc;
  Volume = 2^Dim * Counter / NrOfIterations
end

plot( 1:MaxDim, TimeVector, 'r+')
xlabel('Dimension/1')
ylabel('Time/s')
